# openCL Demo

## 1.简介

OpenCL（Open Computing Language），即开放计算语言，最初由苹果公司(Apple)提出，后交由非盈利组织Khronos维护。使用OpenCL可以让程序内部并发地执行。

## 2.使用指南

### 2.1克隆仓库

```git
git clone https://gitee.com/bianbu-linux/k1x-gpu-test.git
```

### 2.2进到源码目录使用cmake进行编译

```bash
cd k1x-gpu-test/openCLDemo
cmake .
make -j
```

编译完成后会在当前目录下生成 gpu-addDemo 文件，直接运行即可：./gpu-addDemo。如需安装，可在当前目录（即源码目录）下执行 make install 命令，会自动将可执行文件安装到 /usr/local/bin/ 目录下，安装完成后可直接运行：gpu-addDemo。

### 2.3添加Demo

如果增加一个名为 testDemo.c 的文件，并希望编译得到名为 testDemo 的可执行文件，可按以下示例修改CMakeLists.txt

```CMake
# 定义 OpenCL 版本为 300
add_definitions(-DCL_TARGET_OPENCL_VERSION=300)

# 添加链接库
set(LINK_LIBRARIES PVROCL)  //设置链接库变量，指定链接库名称

add_executable(gpu-addDemo ${CMAKE_CURRENT_SOURCE_DIR}/add_demo.c)
add_executable(testDemo ${CMAKE_CURRENT_SOURCE_DIR}/testDemo.c) # 创建新的可执行文件

# 链接库，将指定的链接库与可执行文件链接
target_link_libraries(gpu-addDemo ${LINK_LIBRARIES})
target_link_libraries(testDemo ${LINK_LIBRARIES})

# 安装， 将可执行文件安装到指定目录
install(TARGETS 
gpu-addDemo
testDemo #安装新的可执行文件
DESTINATION "${CMAKE_INSTALL_PREFIX}/bin")
```

然后再次执行 make -j 即可。
